Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/Parameters_msg_error.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/Parameters_msg_error.cpp	(revision 75)
@@ -9,5 +9,4 @@
 #include "Behavioural/Generic/RegisterFile/include/Types.h"
 #include <sstream>
-using namespace std;
 
 namespace morpheo                    {
@@ -17,5 +16,5 @@
 
 
-  string Parameters::msg_error(void)
+  std::string Parameters::msg_error(void)
   {
     log_printf(FUNC,RegisterFile,"msg_error","Begin");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/Parameters_print.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/Parameters_print.cpp	(revision 75)
@@ -8,5 +8,4 @@
 #include "Behavioural/Generic/RegisterFile/include/Parameters.h"
 #include "Behavioural/include/XML.h"
-using namespace std;
 
 namespace morpheo                    {
@@ -16,9 +15,9 @@
 
 
-  string Parameters::print (uint32_t depth)
+  std::string Parameters::print (uint32_t depth)
   {
     log_printf(FUNC,RegisterFile,"print","Begin");
 
-    string _return;
+    std::string _return;
 
     if (_instance == instance_RegisterFile_Monolithic)
@@ -32,11 +31,8 @@
   };
 
-  ostream& operator<< (ostream& output_stream ,
-		       morpheo::behavioural::generic::registerfile::Parameters & x)
+  std::ostream& operator<< (std::ostream& output_stream ,
+			    morpheo::behavioural::generic::registerfile::Parameters & x)
   {
-    if (x._instance == instance_RegisterFile_Monolithic)
-      output_stream << x._param_registerfile_monolithic  ->print(0);
-    else
-      output_stream << x._param_registerfile_multi_banked->print(0);
+    output_stream << x.print(0);
     
     return output_stream;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/RegisterFile.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/RegisterFile.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/RegisterFile.cpp	(revision 75)
@@ -25,7 +25,4 @@
 			      _name              (name)
 			      ,_param            (param)
-#ifdef STATISTICS
-			      ,_param_statistics (param_statistics)
-#endif
   {
     log_printf(FUNC,RegisterFile,"RegisterFile","Begin");
@@ -34,5 +31,16 @@
     log_printf(INFO,RegisterFile,"RegisterFile","Allocation");
 
-    allocation ();
+    allocation (
+# ifdef STATISTICS
+		param_statistics
+# endif
+		);
+#endif
+
+#ifdef STATISTICS
+    if (_param->_instance == instance_RegisterFile_Monolithic)
+      _stat = component_RegisterFile_Monolithic  ->_stat;
+    else
+      _stat = component_RegisterFile_Multi_Banked->_stat;
 #endif
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/RegisterFile_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/RegisterFile_allocation.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/RegisterFile/src/RegisterFile_allocation.cpp	(revision 75)
@@ -15,7 +15,13 @@
 
 
-  void RegisterFile::allocation (void)
+  void RegisterFile::allocation (
+#ifdef STATISTICS
+				 morpheo::behavioural::Parameters_Statistics * param_statistics
+#else
+				 void
+#endif
+				 )
   {
-    string rename;
+    std::string rename;
 
     log_printf(FUNC,RegisterFile,"allocation","Begin");
@@ -78,5 +84,5 @@
 	component_RegisterFile_Monolithic  = new morpheo::behavioural::generic::registerfile::registerfile_monolithic  ::RegisterFile_Monolithic  ::RegisterFile_Monolithic   (_name.c_str()
 #ifdef STATISTICS
-																					       ,_param_statistics
+																					       ,param_statistics
 #endif
 																					       ,_param->_param_registerfile_monolithic
@@ -89,5 +95,5 @@
 	component_RegisterFile_Multi_Banked = new morpheo::behavioural::generic::registerfile::registerfile_multi_banked::RegisterFile_Multi_Banked::RegisterFile_Multi_Banked (_name.c_str()
 #ifdef STATISTICS
-																						,_param_statistics
+																						,param_statistics
 #endif
 																						,_param->_param_registerfile_multi_banked
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/include/Parameters.h	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/include/Parameters.h	(revision 75)
@@ -34,9 +34,8 @@
   public : ~Parameters () ;
 
-  public : string msg_error (void);
-
-  public :        string   print      (uint32_t depth);
-  public : friend ostream& operator<< (ostream& output_stream,
-				       morpheo::behavioural::generic::select::select_priority_fixed::Parameters & x);
+  public :        std::string   msg_error  (void);
+  public :        std::string   print      (uint32_t depth);
+  public : friend std::ostream& operator<< (std::ostream& output_stream,
+					    morpheo::behavioural::generic::select::select_priority_fixed::Parameters & x);
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/include/Select_Priority_Fixed.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/include/Select_Priority_Fixed.h	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/include/Select_Priority_Fixed.h	(revision 75)
@@ -20,5 +20,5 @@
 #include "Behavioural/Generic/Select/Select_Priority_Fixed/include/Types.h"
 #ifdef STATISTICS
-#include "Behavioural/Generic/Select/Select_Priority_Fixed/include/Statistics.h"
+#include "Behavioural/include/Stat.h"
 #endif
 #include "Behavioural/include/Component.h"
@@ -27,6 +27,4 @@
 #endif
 #include "Behavioural/include/Usage.h"
-
-using namespace std;
 
 namespace morpheo {
@@ -44,5 +42,5 @@
     // -----[ fields ]----------------------------------------------------
     // Parameters
-  protected : const string     _name;
+  protected : const std::string     _name;
   protected : const Parameters * _param;
   private   : const Tusage_t     _usage;
@@ -52,5 +50,5 @@
 
 #ifdef STATISTICS
-  private   : Statistics                     * _stat;
+  public    : Stat                           * _stat;
 #endif
 
@@ -87,5 +85,5 @@
    sc_module_name                              name,
 #else					       
-   string                                      name,
+   std::string                                 name,
 #endif					       
 #ifdef STATISTICS
@@ -101,12 +99,9 @@
   private : void     deallocation              (void);
 					       
-#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+# if defined(STATISTICS) or defined(VHDL_TESTBENCH)
   public  : void     transition                (void);
-#endif
+# endif
   public  : void     genMealy_entity           (void);
 #endif					       
-#ifdef STATISTICS
-  public  : string   statistics                (uint32_t depth);
-#endif
 					       
 #if VHDL				       
@@ -116,6 +111,9 @@
 #endif					       
 					       
-#ifdef VHDL_TESTBENCH			       
-  private : void     vhdl_testbench_transition (void);
+#ifdef STATISTICS
+  public  : void        statistics_declaration    (morpheo::behavioural::Parameters_Statistics * param_statistics);
+#endif
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+  private : void        end_cycle                 (void);
 #endif
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Parameters_msg_error.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Parameters_msg_error.cpp	(revision 75)
@@ -9,5 +9,4 @@
 #include "Behavioural/Generic/Select/Select_Priority_Fixed/include/Types.h"
 #include <sstream>
-using namespace std;
 
 namespace morpheo                    {
@@ -18,9 +17,9 @@
 
 
-  string Parameters::msg_error(void)
+  std::string Parameters::msg_error(void)
   {
     log_printf(FUNC,Select_Priority_Fixed,"msg_error","Begin");
 
-    string msg = "";
+    std::string msg = "";
 
     if ((_encoding_one_hot or _encoding_compact) == false)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Parameters_print.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Parameters_print.cpp	(revision 75)
@@ -8,5 +8,4 @@
 #include "Behavioural/Generic/Select/Select_Priority_Fixed/include/Parameters.h"
 #include "Behavioural/include/XML.h"
-using namespace std;
 
 namespace morpheo                    {
@@ -16,5 +15,5 @@
 namespace select_priority_fixed {
 
-  string Parameters::print (uint32_t depth)
+  std::string Parameters::print (uint32_t depth)
   {
     log_printf(FUNC,Select_Priority_Fixed,"print","Begin");
@@ -33,6 +32,6 @@
   };
 
-  ostream& operator<< (ostream& output_stream ,
-		       morpheo::behavioural::generic::select::select_priority_fixed::Parameters & x)
+  std::ostream& operator<< (std::ostream& output_stream ,
+			    morpheo::behavioural::generic::select::select_priority_fixed::Parameters & x)
   {
     output_stream << x.print(0);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed.cpp	(revision 75)
@@ -30,7 +30,4 @@
     _param            (param),
     _usage            (usage)
-// #ifdef STATISTICS
-// 			      ,_param_statistics (param_statistics)
-// #endif
   {
     log_printf(FUNC,Select_Priority_Fixed,"Select_Priority_Fixed","Begin");
@@ -44,8 +41,5 @@
 	log_printf(INFO,Select_Priority_Fixed,"Select_Priority_Fixed","Allocation of statistics");
 	
-	// Allocation of statistics
-	_stat = new Statistics (static_cast<string>(_name),
-				param_statistics          ,
-				param);
+	statistics_declaration(param_statistics);
       }
 #endif
@@ -106,5 +100,4 @@
 	log_printf(INFO,Select_Priority_Fixed,"~Select_Priority_Fixed","Generate Statistics file");
 	
-	_stat->generate_file(statistics(0));
 	delete _stat;
       }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_end_cycle.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_end_cycle.cpp	(revision 75)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_end_cycle.cpp	(revision 75)
@@ -0,0 +1,42 @@
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/Select/Select_Priority_Fixed/include/Select_Priority_Fixed.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace select {
+namespace select_priority_fixed {
+
+#undef  FUNCTION
+#define FUNCTION "Select_Priority_Fixed::end_cycle"
+void Select_Priority_Fixed::end_cycle ()
+  {
+    log_printf(FUNC,Select_Priority_Fixed,FUNCTION,"Begin");
+
+#ifdef STATISTICS
+    _stat->end_cycle();
+#endif    
+
+#ifdef VHDL_TESTBENCH
+    // Evaluation before read the ouput signal
+//  sc_start(0);
+    _interfaces->testbench();
+#endif
+
+    log_printf(FUNC,Select_Priority_Fixed,FUNCTION,"End");
+  };
+
+}; // end namespace select_priority_fixed
+}; // end namespace select
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_statistics_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_statistics_declaration.cpp	(revision 75)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_statistics_declaration.cpp	(revision 75)
@@ -0,0 +1,36 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/Select/Select_Priority_Fixed/include/Select_Priority_Fixed.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace generic {
+namespace select {
+namespace select_priority_fixed {
+
+#undef  FUNCTION
+#define FUNCTION "Select_Priority_Fixed::statistics_declaration"
+  void Select_Priority_Fixed::statistics_declaration (morpheo::behavioural::Parameters_Statistics * param_statistics)
+  {
+    log_printf(FUNC,Select_Priority_Fixed,FUNCTION,"Begin");
+
+    _stat = new Stat (static_cast<std::string>(_name),
+		      "Select_Priority_Fixed",
+		      param_statistics);
+    
+    log_printf(FUNC,Select_Priority_Fixed,FUNCTION,"End");
+  };
+
+}; // end namespace select_priority_fixed
+}; // end namespace select
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_transition.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_transition.cpp	(revision 75)
@@ -21,10 +21,6 @@
     log_printf(FUNC,Select_Priority_Fixed,"transition","Begin");
 
-#ifdef STATISTICS
-    _stat->add();
-#endif    
-
-#ifdef VHDL_TESTBENCH
-    vhdl_testbench_transition ();
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+    end_cycle();
 #endif
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_vhdl_body.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_vhdl_body.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Select/Select_Priority_Fixed/src/Select_Priority_Fixed_vhdl_body.cpp	(revision 75)
@@ -38,5 +38,5 @@
     if (_param->_encoding_compact)
       {
-	string range = ((_param->_size_entity-1)==0)?"(0)":std_logic_range(_param->_size_entity-1,0);
+	std::string range = ((_param->_size_entity-1)==0)?"(0)":std_logic_range(_param->_size_entity-1,0);
 
 	vhdl->set_body ("out_ENTITY     <=     internal_entity"+range+";");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/src/test.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/SelfTest/src/test.cpp	(revision 75)
@@ -33,9 +33,13 @@
       exit (EXIT_FAILURE);
     }
+
+#ifdef STATISTICS
+  morpheo::behavioural::Parameters_Statistics * param_stat = new morpheo::behavioural::Parameters_Statistics(5,50);
+#endif
   Shifter * _Shifter = new Shifter (name.c_str(),
 #ifdef STATISTICS
-					     morpheo::behavioural::Parameters_Statistics(5,50),
-#endif
-					     param);
+				    param_stat,
+#endif
+				    param);
   
 #ifdef SYSTEMC
@@ -48,5 +52,5 @@
   sc_signal <Tshift_t    >                 SHIFTER_SHIFT     [param._nb_port];
   sc_signal <Tdirection_t>                 SHIFTER_DIRECTION [param._nb_port];
-  sc_signal <Ttype_t     >                 SHIFTER_TYPE      [param._nb_port];
+  sc_signal <morpheo::behavioural::generic::shifter::Ttype_t     >                 SHIFTER_TYPE      [param._nb_port];
   sc_signal <Tcarry_t    >                 SHIFTER_CARRY     [param._nb_port];
   sc_signal <Tcontrol_t  >                 SHIFTER_CARRY_IN  [param._nb_port];
@@ -96,5 +100,5 @@
 
   Tdirection_t   direction       ;
-  Ttype_t        type            ;
+  morpheo::behavioural::generic::shifter::Ttype_t        type            ;
   Tcarry_t       carry           ; 
   const Tdata_t  data_max        = (1<<param._size_data);
@@ -271,11 +275,11 @@
 		       << hex
 		       << data_in[i] << op
-		       << dec 
+		       << std::dec 
 		       << shift      << " = " 
-		       << hex
+		       << std::hex
 		       << SHIFTER_DATA_OUT [i].read()
 		       << " - completion : "
 		       << data_completion [i]
-		       << dec ;
+		       << std::dec ;
 		  
 		  TEST(Tdata_t,SHIFTER_DATA_OUT [i].read(),data_out[i]);
@@ -298,3 +302,7 @@
 
   delete _Shifter;
+
+#ifdef STATISTICS
+  delete param_stat;
+#endif
 }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/include/Parameters.h	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/include/Parameters.h	(revision 75)
@@ -48,38 +48,4 @@
   public : const bool        _have_direction_right         ;
 
-    string toString_rotate    (rotate_t x)
-    {
-      switch (x)
-	{
-	case without_rotate            : return "without_rotate" ;
-	case internal_rotate           : return "internal_rotate";
-	case external_rotate           : return "external_rotate";     
-	default                        : return "";
-	}
-    };
-    
-    string toString_direction (direction_t x) 
-    {
-      switch (x)
-	{
-	case internal_right_shift      : return "internal_right_shift";
-	case internal_left_shift       : return "internal_left_shift" ;
-	case external_direction        : return "external_direction"  ;
-	default                        : return "";
-	}
-    };
-    
-    string toString_carry (carry_t x)
-    {
-      switch (x)
-	{
-	case internal_logic            : return "internal_logic"       ;
-	case internal_arithmetic       : return "internal_arithmetic"  ;
-	case external_carry            : return "external_carry"       ;
-	case external_completion       : return "external_completion"  ;
-	default                        : return "";
-	}
-    };
-    
     //-----[ methods ]-----------------------------------------------------------
   public : Parameters  (uint32_t    size_data           ,
@@ -93,9 +59,8 @@
   public : ~Parameters () ;
 
-  public : string msg_error (void);
-
-  public :        string   print      (uint32_t depth);
-  public : friend ostream& operator<< (ostream& output_stream,
-				       morpheo::behavioural::generic::shifter::Parameters & x);
+  public :        std::string   msg_error  (void);
+  public :        std::string   print      (uint32_t depth);
+  public : friend std::ostream& operator<< (std::ostream& output_stream,
+					    morpheo::behavioural::generic::shifter::Parameters & x);
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/include/Shifter.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/include/Shifter.h	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/include/Shifter.h	(revision 75)
@@ -19,5 +19,5 @@
 #include "Behavioural/Generic/Shifter/include/Types.h"
 #ifdef STATISTICS
-#include "Behavioural/Generic/Shifter/include/Statistics.h"
+#include "Behavioural/include/Stat.h"
 #endif
 #ifdef VHDL
@@ -25,6 +25,4 @@
 #endif
 #include "Behavioural/include/Component.h"
-
-using namespace std;
 
 namespace morpheo                    {
@@ -41,9 +39,9 @@
     // -----[ fields ]----------------------------------------------------
     // Parameters
-  protected : const string     _name;
+  protected : const std::string     _name;
 
   protected : const Parameters _param;
 #ifdef STATISTICS
-  private   : Statistics                     * _stat;
+  public    : Stat                           * _stat;
 #endif
 
@@ -79,12 +77,12 @@
   public  :          Shifter              (
 #ifdef SYSTEMC
-					   sc_module_name                              name,
+					   sc_module_name                                name,
 #else					       
-					   string                                      name,
+					   std::string                                   name,
 #endif					       
 #ifdef STATISTICS
-					   morpheo::behavioural::Parameters_Statistics param_statistics,
+					   morpheo::behavioural::Parameters_Statistics * param_statistics,
 #endif
-					   Parameters                                  param );
+					   Parameters                                    param );
     
   public  :          Shifter              (Parameters param );
@@ -106,12 +104,11 @@
   private : void     vhdl_body                 (Vhdl * & vhdl);
 #endif					       
+
 #ifdef STATISTICS
-  public  : string   statistics                (uint32_t depth);
+  public  : void        statistics_declaration    (morpheo::behavioural::Parameters_Statistics * param_statistics);
 #endif
-					       
-#ifdef VHDL_TESTBENCH			       
-  private : void     vhdl_testbench_transition (void);
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+  private : void        end_cycle                 (void);
 #endif
-
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/include/Types.h	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/include/Types.h	(revision 75)
@@ -1,3 +1,2 @@
-#ifdef SYSTEMC
 #ifndef morpheo_behavioural_generic_shifter_Type_h
 #define morpheo_behavioural_generic_shifter_Type_h
@@ -10,5 +9,6 @@
  */
 
-#include "Common/include/Types.h"
+#include "Behavioural/include/Types.h"
+#include "Common/include/ToString.h"
 
 namespace morpheo {
@@ -49,6 +49,41 @@
 }; // end namespace generic
 }; // end namespace behavioural
+
+  template<> inline std::string toString<morpheo::behavioural::generic::shifter::rotate_t>(const morpheo::behavioural::generic::shifter::rotate_t& x)
+    {
+      switch (x)
+	{
+	case morpheo::behavioural::generic::shifter::without_rotate            : return "without_rotate" ;
+	case morpheo::behavioural::generic::shifter::internal_rotate           : return "internal_rotate";
+	case morpheo::behavioural::generic::shifter::external_rotate           : return "external_rotate";     
+	default                        : return "";
+	}
+    };
+  
+  template<> inline std::string toString<morpheo::behavioural::generic::shifter::direction_t>(const morpheo::behavioural::generic::shifter::direction_t& x) 
+  {
+    switch (x)
+      {
+      case morpheo::behavioural::generic::shifter::internal_right_shift      : return "internal_right_shift";
+      case morpheo::behavioural::generic::shifter::internal_left_shift       : return "internal_left_shift" ;
+      case morpheo::behavioural::generic::shifter::external_direction        : return "external_direction"  ;
+      default                        : return "";
+      }
+  };
+  
+  template<> inline std::string toString<morpheo::behavioural::generic::shifter::carry_t>(const morpheo::behavioural::generic::shifter::carry_t& x)
+  {
+    switch (x)
+      {
+      case morpheo::behavioural::generic::shifter::internal_logic            : return "internal_logic"       ;
+      case morpheo::behavioural::generic::shifter::internal_arithmetic       : return "internal_arithmetic"  ;
+      case morpheo::behavioural::generic::shifter::external_carry            : return "external_carry"       ;
+      case morpheo::behavioural::generic::shifter::external_completion       : return "external_completion"  ;
+      default                        : return "";
+      }
+  };
+    
+
 }; // end namespace morpheo              
 
 #endif
-#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Parameters_msg_error.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Parameters_msg_error.cpp	(revision 75)
@@ -9,5 +9,4 @@
 #include "Behavioural/Generic/Shifter/include/Types.h"
 #include <sstream>
-using namespace std;
 
 namespace morpheo {
@@ -16,7 +15,7 @@
 namespace shifter {
 
-  string Parameters::msg_error(void)
+  std::string Parameters::msg_error(void)
   {
-    string msg = "";
+    std::string msg = "";
 
     if (_size_data < 2)
@@ -42,6 +41,6 @@
       {
 	msg += "  - Incompatible parameters : internal_rotate have never carry (must be set at \"internal_logic\"\n";
-        msg += "    * rotate                          : " + toString_rotate(_rotate) + "\n";
-        msg += "    * carry                           : " + toString_carry (_carry ) + "\n";
+        msg += "    * rotate                          : " + toString(_rotate) + "\n";
+        msg += "    * carry                           : " + toString(_carry ) + "\n";
       }    
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Parameters_print.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Parameters_print.cpp	(revision 75)
@@ -7,6 +7,5 @@
 
 #include "Behavioural/Generic/Shifter/include/Parameters.h"
-#include <sstream>
-using namespace std;
+#include "Behavioural/include/XML.h"
 
 namespace morpheo                    {
@@ -16,23 +15,21 @@
 
 
-  string Parameters::print (uint32_t depth)
+  std::string Parameters::print (uint32_t depth)
   {
-    string tab = string(depth,'\t');
-    ostringstream msg;
-    msg << tab << "<shifter>" << endl
-	<< tab << "\t<size_data   value=\"" << _size_data   << "\" />" << endl
-	<< tab << "\t<nb_port     value=\"" << _nb_port     << "\" />" << endl
-	<< tab << "\t<shift_value value=\"" << _shift_value << "\" />" << endl
-	<< tab << "\t<rotate      value=\"" << toString_rotate    (_rotate   ) << "\" />" << endl
-	<< tab << "\t<direction   value=\"" << toString_direction (_direction) << "\" />" << endl
-	<< tab << "\t<carry       value=\"" << toString_carry     (_carry    ) << "\" />" << endl
-	<< tab << "\t<!-- port_completion is type bool : " << toString(_type_completion_bool) << " -->" << endl
-      	<< tab << "</shifter>" << endl;
+    XML xml ("shifter");
+
+    xml.balise_open("shifter");
+    xml.singleton_begin("size_data  "); xml.attribut("value",toString(_size_data  )); xml.singleton_end();
+    xml.singleton_begin("nb_port    "); xml.attribut("value",toString(_nb_port    )); xml.singleton_end();
+    xml.singleton_begin("shift_value"); xml.attribut("value",toString(_shift_value)); xml.singleton_end();
+    xml.singleton_begin("rotate     "); xml.attribut("value",toString(_rotate     )); xml.singleton_end();
+    xml.singleton_begin("direction  "); xml.attribut("value",toString(_direction  )); xml.singleton_end();
+    xml.singleton_begin("carry      "); xml.attribut("value",toString(_carry      )); xml.singleton_end();
     
-    return msg.str();
+    return xml.get_body(depth);
   };
 
-  ostream& operator<< (ostream& output_stream ,
-		       morpheo::behavioural::generic::shifter::Parameters & x)
+  std::ostream& operator<< (std::ostream& output_stream ,
+			    morpheo::behavioural::generic::shifter::Parameters & x)
   {
     output_stream << x.print(0);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter.cpp	(revision 75)
@@ -20,5 +20,5 @@
 #endif
 #ifdef STATISTICS
-		    ,morpheo::behavioural::Parameters_Statistics             param_statistics
+		    ,morpheo::behavioural::Parameters_Statistics * param_statistics
 #endif
 		    ,morpheo::behavioural::generic::shifter::Parameters param ):
@@ -32,7 +32,5 @@
 #ifdef STATISTICS
     // Allocation of statistics
-    _stat = new Statistics (static_cast<string>(_name),
-			    param_statistics          ,
-			    param);
+    statistics_declaration(param_statistics);
 #endif
 
@@ -101,6 +99,4 @@
 
 #ifdef STATISTICS
-    _stat->generate_file(statistics(0));
-    
     delete _stat;
 #endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_end_cycle.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_end_cycle.cpp	(revision 75)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_end_cycle.cpp	(revision 75)
@@ -0,0 +1,41 @@
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/Shifter/include/Shifter.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace shifter {
+
+#undef  FUNCTION
+#define FUNCTION "Shifter::end_cycle"
+void Shifter::end_cycle ()
+  {
+    log_printf(FUNC,Shifter,FUNCTION,"Begin");
+
+#ifdef STATISTICS
+    _stat->end_cycle();
+#endif    
+
+#ifdef VHDL_TESTBENCH
+    // Evaluation before read the ouput signal
+//  sc_start(0);
+    _interfaces->testbench();
+#endif
+
+    log_printf(FUNC,Shifter,FUNCTION,"End");
+  };
+
+
+}; // end namespace shifter
+}; // end namespace generic
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_genMealy_shift.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_genMealy_shift.cpp	(revision 74)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Shifter/src/Shifter_genMealy_shift.cpp	(revision 75)
@@ -11,5 +11,4 @@
 #include <bitset>
 
-using namespace std;
 namespace morpheo {
 namespace behavioural {
